#ifndef _KGR_PATCH_BSC1188613_H
#define _KGR_PATCH_BSC1188613_H

#if IS_ENABLED(CONFIG_BT)

int kgr_patch_bsc1188613_init(void);
void kgr_patch_bsc1188613_cleanup(void);


struct hci_conn;
struct sock;
struct socket;
struct msghdr;

void kgrp_sco_conn_del(struct hci_conn *hcon, int err);
void kgrp___sco_sock_close(struct sock *sk);
int kgrp_sco_sock_sendmsg(struct socket *sock, struct msghdr *msg,
			    size_t len);
int kgrp_sco_sock_recvmsg(struct socket *sock, struct msghdr *msg,
			    size_t len, int flags);
int kgrp_sco_sock_getsockopt(struct socket *sock, int level, int optname,
			       char __user *optval, int __user *optlen);

#define KGR_PATCH_BSC1188613_FUNCS					\
	KGR_PATCH_OBJ(sco_conn_del, kgrp_sco_conn_del, "bluetooth"),	\
	KGR_PATCH_OBJ(__sco_sock_close, kgrp___sco_sock_close,		\
		      "bluetooth"),					\
	KGR_PATCH_OBJ(sco_sock_sendmsg, kgrp_sco_sock_sendmsg,		\
		      "bluetooth"),					\
	KGR_PATCH_OBJ(sco_sock_recvmsg, kgrp_sco_sock_recvmsg,		\
		      "bluetooth"),					\
	KGR_PATCH_OBJ(sco_sock_getsockopt, kgrp_sco_sock_getsockopt,	\
		      "bluetooth"),					\

#else /* !IS_ENABLED(CONFIG_BT) */

static inline int kgr_patch_bsc1188613_init(void) { return 0; }

static inline void kgr_patch_bsc1188613_cleanup(void) {}

#define KGR_PATCH_BSC1188613_FUNCS

#endif /* IS_ENABLED(CONFIG_BT) */
#endif /* _KGR_PATCH_BSC1188613_H */
